<?php

namespace NoccyLabs\App\Trait;

use NoccyLabs\App\Attribute\AppInfo;
use NoccyLabs\App\Trait\Lockfile\Lockfile;
use ReflectionClass;

trait LockfileTrait
{
    private ?Lockfile $lock = null;

    private function getDefaultLockfile()
    {
        return realpath($GLOBALS['argv'][0]).".lock";
    }

    protected function lockfile(?string $filename=null)
    {
        $filename ??= $this->getDefaultLockfile();

        $this->lock = new Lockfile($filename);
        $this->lock->acquire();
    }

    protected function unlockfile()
    {
        if ($this->lock) {
            $this->lock->release();
            $this->lock = null;
        }
    }

}