<?php

namespace NoccyLabs\App\Trait;

use NoccyLabs\App\Attribute\AppInfo;
use NoccyLabs\App\Trait\Lockfile\Lockfile;
use Phar;
use ReflectionClass;
use Psr\Log\LoggerInterface;

trait LoggingTrait
{

    private ?LoggerInterface $logger = null;

    protected function setLogger(?LoggerInterface $logger)
    {
        $this->logger = $logger;
    }

    public function log($level, $message, array $context=[])
    {
        if (!$this->logger) {
            printf("%s: %s %s\n", $level, $message, $context?json_encode($context,JSON_UNESCAPED_SLASHES):"");
        } else {
            $this->logger->log($level, $message, $context);
        }
    }

}
