<?php

namespace NoccyLabs\App\Trait;

use NoccyLabs\App\Attribute\AppInfo;
use NoccyLabs\App\Trait\Lockfile\Lockfile;
use Phar;
use ReflectionClass;

trait OutputTrait
{

    public function write(string $text, bool $highlight=false)
    {
        $out = $text;
        if (!posix_isatty(STDOUT)) {
            $out = preg_replace("<\e\[[0-9;]+?m>", "", $out);
        } elseif ($highlight) {
            $out = preg_replace("<\{(\w+)\}>", "{\e[4;3m$1\e[24;23m}", $out);
            $out = preg_replace("<(-{1,2}[a-z-]+)([\s,\)])>", "\e[0;33m$1\e[0m$2", $out);
        }
        echo $out;
    }

    public function writeln(string $text)
    {
        $this->write($text."\n");
    }

}
